<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.car_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/estate/car";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "车牌号",
              prop: "number",
              rules: [{
                required: true,
                message: "请输入车牌号",
                trigger: "blur"
              }]
            },
            {
              label: "车辆类型",
              prop: "type",
              rules: [{
                required: true,
                message: "请输入车辆类型",
                trigger: "blur"
              }]
            },
            {
              label: "车辆性质(货运、客运、营运、非运营,出租)",
              prop: "properties",
              rules: [{
                required: true,
                message: "请输入车辆性质(货运、客运、营运、非运营,出租)",
                trigger: "blur"
              }]
            },
            {
              label: "车辆型号",
              prop: "model",
              rules: [{
                required: true,
                message: "请输入车辆型号",
                trigger: "blur"
              }]
            },
            {
              label: "燃油类别",
              prop: "fuelCategory",
              rules: [{
                required: true,
                message: "请输入燃油类别",
                trigger: "blur"
              }]
            },
            {
              label: "车身颜色",
              prop: "color",
              rules: [{
                required: true,
                message: "请输入车身颜色",
                trigger: "blur"
              }]
            },
            {
              label: "车主姓名",
              prop: "personName",
              rules: [{
                required: true,
                message: "请输入车主姓名",
                trigger: "blur"
              }]
            },
            {
              label: "车主电话",
              prop: "personPhone",
              rules: [{
                required: true,
                message: "请输入车主电话",
                trigger: "blur"
              }]
            },
            {
              label: "社区ID",
              prop: "agencyId",
              rules: [{
                required: true,
                message: "请输入社区ID",
                trigger: "blur"
              }]
            },
            {
              label: "小区id",
              prop: "residentialId",
              rules: [{
                required: true,
                message: "请输入小区id",
                trigger: "blur"
              }]
            },
            {
              label: "车辆照片",
              prop: "carImg",
              rules: [{
                required: true,
                message: "请输入车辆照片",
                trigger: "blur"
              }]
            },
            {
              label: "企业id",
              prop: "enterpriseId",
              rules: [{
                required: true,
                message: "请输入企业id",
                trigger: "blur"
              }]
            },
            {
              label: "机构路径",
              prop: "orgPosition",
              rules: [{
                required: true,
                message: "请输入机构路径",
                trigger: "blur"
              }]
            },
            {
              label: "车主id:若为社区租户则为住户id，若为园区租户则为员工id",
              prop: "personId",
              rules: [{
                required: true,
                message: "请输入车主id:若为社区租户则为住户id，若为园区租户则为员工id",
                trigger: "blur"
              }]
            },
            {
              label: "所属停车场id",
              prop: "parkingLotId",
              rules: [{
                required: true,
                message: "请输入所属停车场id",
                trigger: "blur"
              }]
            },
            {
              label: "行驶证正面图片地址",
              prop: "vehicleDrivingLicense1",
              rules: [{
                required: true,
                message: "请输入行驶证正面图片地址",
                trigger: "blur"
              }]
            },
            {
              label: "审核状态：-1 审核不通过  0-待审核 1-审核通过",
              prop: "auditStatus",
              rules: [{
                required: true,
                message: "请输入审核状态：-1 审核不通过  0-待审核 1-审核通过",
                trigger: "blur"
              }]
            },
            {
              label: "审核意见",
              prop: "auditOpinion",
              rules: [{
                required: true,
                message: "请输入审核意见",
                trigger: "blur"
              }]
            },
            {
              label: "行驶证背面图片地址",
              prop: "vehicleDrivingLicense2",
              rules: [{
                required: true,
                message: "请输入行驶证背面图片地址",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.car_add, false),
          viewBtn: this.vaildData(this.permission.car_view, false),
          delBtn: this.vaildData(this.permission.car_delete, false),
          editBtn: this.vaildData(this.permission.car_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
